/*
 * Copyright 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.dev.cfg;

import com.google.gwt.dev.js.ast.JsBlock;

/**
 * Produces a deferred binding property value by executing JavaScript code.
 */
public class PropertyProvider {

  private JsBlock body;

  private final Property property;

  public PropertyProvider(Property property) {
    this.property = property;
  }

  public JsBlock getBody() {
    return body;
  }

  public Property getProperty() {
    return property;
  }

  public void setBody(JsBlock body) {
    this.body = body;
  }
}
