/*
 * Copyright 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.dev.js.ast;

/**
 * Implements stubs for the <code>endVisit()</code> interface methods.
 */
public abstract class JsAbstractVisitorWithEndVisits implements JsVisitor {

  public void endVisit(JsArrayAccess x) {
  }

  public void endVisit(JsArrayLiteral x) {
  }

  public void endVisit(JsBinaryOperation x) {
  }

  public void endVisit(JsBlock x) {
  }

  public void endVisit(JsBooleanLiteral x) {
  }

  public void endVisit(JsBreak x) {
  }

  public void endVisit(JsCase x) {
  }

  public void endVisit(JsCatch x) {
  }

  public void endVisit(JsConditional x) {
  }

  public void endVisit(JsContinue x) {
  }

  public void endVisit(JsDecimalLiteral x) {
  }

  public void endVisit(JsDefault x) {
  }

  public void endVisit(JsDelete x) {
  }

  public void endVisit(JsDoWhile while1) {
  }

  public void endVisit(JsEmpty x) {
  }

  public void endVisit(JsExprStmt x) {
  }

  public void endVisit(JsFor x) {
  }

  public void endVisit(JsForIn x) {
  }

  public void endVisit(JsFunction x) {
  }

  public void endVisit(JsIf x) {
  }

  public void endVisit(JsIntegralLiteral x) {
  }

  public void endVisit(JsInvocation x) {
  }

  public void endVisit(JsLabel x) {
  }

  public void endVisit(JsNameRef x) {
  }

  public void endVisit(JsNew x) {
  }

  public void endVisit(JsNullLiteral x) {
  }

  public void endVisit(JsObjectLiteral x) {
  }

  public void endVisit(JsParameter x) {
  }

  public void endVisit(JsParameters x) {
  }

  public void endVisit(JsPostfixOperation x) {
  }

  public void endVisit(JsPrefixOperation x) {
  }

  public void endVisit(JsProgram x) {
  }

  public void endVisit(JsPropertyInitializer x) {
  }

  public void endVisit(JsRegExp x) {
  }

  public void endVisit(JsReturn x) {
  }

  public void endVisit(JsStringLiteral x) {
  }

  public void endVisit(JsSwitch x) {
  }

  public void endVisit(JsThisRef x) {
  }

  public void endVisit(JsThrow x) {
  }

  public void endVisit(JsTry x) {
  }

  public void endVisit(JsVars x) {
  }

  public void endVisit(JsWhile x) {
  }
}
