/*
 * Copyright 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.dev.js.ast;

/**
 * Represents the JavaScript delete statement.
 */
public class JsDelete extends JsExpression {

  private JsExpression toDelete;

  public JsDelete() {
  }

  public JsExpression getExpr() {
    return toDelete;
  }

  public void setExpr(JsArrayAccess arrayElem) {
    this.toDelete = arrayElem;
  }

  public void setExpr(JsNameRef nameRef) {
    this.toDelete = nameRef;
  }

  public void traverse(JsVisitor v) {
    if (v.visit(this)) {
      toDelete.traverse(v);
    }
    v.endVisit(this);
  }
}
